/******************************************************************************
USB-RAD121 Example Code
    Copyright (C) 2013 Magnii Technologies, LLC
    http://www.magnii.com/
    Release Date: May 4, 2013

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
******************************************************************************/

#ifndef CUSB_RAD121_H
#define CUSB_RAD121_H

#include <windows.h>
#include <time.h>
#include "FTD2XX.h"

// USB-RAD121 Calibration Values
const double USB_RAD121_SENSITIVITY = 450.0;        // USB-RAD121 Sensitivity, in cpm/mR/hr
const double USB_RAD121_DEAD_TIME   = 0.00015;        // USB-RAD121 Geiger Tube Dead Time, in seconds

class CUSB_RAD121
{
private:
    FT_HANDLE ftHandle;
    clock_t LastCountsTime;

public:
    CUSB_RAD121();
    ~CUSB_RAD121();

    bool Open();
    bool Close();
    bool GetReading( double *CountsPerMinute );
    bool SetDeviceBeep( bool BeepEnabled );

    static double Calculate_CompensatedCPM( double CountsPerMinute );
    static double Calculate_mRhr( double CountsPerMinute );
};

#endif